#include <extdll.h>

#include <h_export.h>
#include <meta_api.h>

#include <dllapi.h>

#include "vers_plugin.h"


static cvar_t unstuck_cvars[] = {
	{"unstuck_version",		VVERSION,	FCVAR_EXTDLL | FCVAR_SERVER , 0, NULL},
	{"unstuck_timer",		"6.0",		FCVAR_EXTDLL, 6.0, NULL},
	
	{NULL,NULL,0,0,NULL},
};


extern float player_timer[33];

// Plugin startup.  Register commands and cvars.
static void plugin_init(void)
{
	unsigned i;
	
	for(i=0;unstuck_cvars[i].name;i++) CVAR_REGISTER(&unstuck_cvars[i]);
	
	for(i=0;i<(sizeof(player_timer)/sizeof(player_timer[0]));i++)
		player_timer[i] = 0.0f;
}

extern "C" int Get_Entity_API2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion );

// Description of plugin.
// (V* info from vers_plugin.h)
plugin_info_t Plugin_info = {
	META_INTERFACE_VERSION, // ifvers
	VNAME,			// name
	VVERSION,		// version
	VDATE,			// date
	VAUTHOR,		// author
	VURL,			// url
	VLOGTAG,		// logtag
	PT_ANYPAUSE,		// loadable
	PT_ANYPAUSE,		// unloadable
};

// Global variables from metamod.  These variable names are referenced by
// various macros.
meta_globals_t *gpMetaGlobals;		// metamod globals
gamedll_funcs_t *gpGamedllFuncs;	// gameDLL function tables
mutil_funcs_t *gpMetaUtilFuncs;		// metamod utility functions


// Metamod requesting info about this plugin
C_DLLEXPORT int Meta_Query(char *ifvers, plugin_info_t **pPlugInfo, mutil_funcs_t *pMetaUtilFuncs) 
{
	try {
		// Check for valid pMetaUtilFuncs before we continue.
		if(!pMetaUtilFuncs) { return(FALSE); }
	
		gpMetaUtilFuncs=pMetaUtilFuncs;

		// Give metamod our plugin_info struct.
		*pPlugInfo=&Plugin_info;

		// Check for interface version compatibility.
		if(!FStrEq(ifvers, Plugin_info.ifvers)) 
		{
			//Lazy method
	 		Plugin_info.ifvers=strdup(ifvers);
		}
	}
	catch(...)
	{
		return( FALSE );
	}
	
	return(TRUE);
}

// Metamod attaching plugin to the server.
C_DLLEXPORT int Meta_Attach(PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs)
{
	try {
		if(now > Plugin_info.loadable) 
		{
			return(FALSE);
		}
	
		if(!pMGlobals) 
		{
			return(FALSE);
		}
	
		gpMetaGlobals=pMGlobals;
	
		if(!pFunctionTable) 
		{
			return(FALSE);
		}
	
	
		memset(pFunctionTable,0,sizeof(META_FUNCTIONS));
		pFunctionTable->pfnGetEntityAPI2 = Get_Entity_API2;
	
	
		gpGamedllFuncs=pGamedllFuncs;


		// Let's go.	
		plugin_init();
	
	}
	catch(...)
	{
		return( FALSE );
	}
	
	return(TRUE);
}


// Metamod detaching plugin from the server.
C_DLLEXPORT int Meta_Detach(PLUG_LOADTIME now, PL_UNLOAD_REASON reason) 
{
	try {
		if(now > Plugin_info.unloadable && reason != PNL_CMD_FORCED) 
		{
			return(FALSE);
		}
	}
	catch(...)
	{
		return(FALSE);
	}

	return(TRUE);
}


//! Holds engine functionality callbacks
enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;


// Receive engine function table from engine.
C_DLLEXPORT void DLLEXPORT WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	try {
		memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
		gpGlobals = pGlobals;
	}
	catch(...)
	{
		return;
	}
	
	return;
}


#ifdef _WIN32
BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved) {return TRUE;}
#endif


